//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: ServerSideFrame.java,v 1.1.1.1 2002/06/10 20:53:31 jgiacomo Exp $
//
/*
 * ServerSideFrame.java
 *
 * Created on January 2, 2002, 3:12 PM
 */

package siena.xml.demo;

/**
 *
 * @author  unknown
 */
public class ServerSideFrame extends javax.swing.JFrame {

    siena.xml.XMLClient xmlInterface = null;
    
    String notification = null;
    
    String serverName = null;
    
    int serverPort = 0;
    
    String xschemaFile = null;
    
    /** Creates new form ServerSideFrame */
    public ServerSideFrame() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPopupMenu1 = new javax.swing.JPopupMenu();
        sendMenuItem = new javax.swing.JMenuItem();
        clearMenuItem = new javax.swing.JMenuItem();
        jScrollPane1 = new javax.swing.JScrollPane();
        notificationView = new javax.swing.JTextArea();
        jToolBar1 = new javax.swing.JToolBar();
        serverButton = new javax.swing.JButton();
        xschemaButton = new javax.swing.JButton();
        notificationButton = new javax.swing.JButton();
        setRulesButton = new javax.swing.JButton();
        clearRulesButton = new javax.swing.JButton();
        sendButton = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        exitButton = new javax.swing.JButton();
        
        sendMenuItem.setText("Clear Output Window");
        sendMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sendAction(evt);
            }
        });
        
        jPopupMenu1.add(sendMenuItem);
        clearMenuItem.setText("Send Notfication");
        clearMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearMenuItemActionPerformed(evt);
            }
        });
        
        jPopupMenu1.add(clearMenuItem);
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        notificationView.setToolTipText("Output Window");
        notificationView.setEditable(false);
        notificationView.setTabSize(4);
        jScrollPane1.setViewportView(notificationView);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 467;
        gridBagConstraints1.ipady = 290;
        getContentPane().add(jScrollPane1, gridBagConstraints1);
        
        serverButton.setToolTipText("Configure the SIENA server");
        serverButton.setText("Server");
        serverButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                serverButtonActionPerformed(evt);
            }
        });
        
        jToolBar1.add(serverButton);
        
        xschemaButton.setToolTipText("Indicate where the XSchema file is");
        xschemaButton.setText("XSchema");
        xschemaButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                xschemaButtonActionPerformed(evt);
            }
        });
        
        jToolBar1.add(xschemaButton);
        
        notificationButton.setToolTipText("Build or Load a XML notification");
        notificationButton.setText("Notification");
        notificationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                notificationButtonActionPerformed(evt);
            }
        });
        
        jToolBar1.add(notificationButton);
        
        setRulesButton.setToolTipText("Set the users rules");
        setRulesButton.setText("Set Rules");
        setRulesButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setRulesButtonActionPerformed(evt);
            }
        });
        
        jToolBar1.add(setRulesButton);
        
        clearRulesButton.setToolTipText("Clear the User Rules");
        clearRulesButton.setText("Clear Rules");
        clearRulesButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearRulesButtonActionPerformed(evt);
            }
        });
        
        jToolBar1.add(clearRulesButton);
        
        sendButton.setToolTipText("Send the loaded notification");
        sendButton.setText("Send!");
        sendButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sendAction(evt);
            }
        });
        
        jToolBar1.add(sendButton);
        
        jToolBar1.add(jSeparator1);
        
        exitButton.setToolTipText("Quit the program");
        exitButton.setText("Exit");
        exitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitButtonActionPerformed(evt);
            }
        });
        
        jToolBar1.add(exitButton);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 144;
        gridBagConstraints1.ipady = 3;
        getContentPane().add(jToolBar1, gridBagConstraints1);
        
        pack();
    }//GEN-END:initComponents

    private void exitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitButtonActionPerformed
        exitForm(null);
    }//GEN-LAST:event_exitButtonActionPerformed

    private void clearMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearMenuItemActionPerformed
        notificationView.setText("");
    }//GEN-LAST:event_clearMenuItemActionPerformed

    private void sendAction(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sendAction
        String xmlNotification = notificationDialog.getNotification();
        if (xmlNotification == null || xmlNotification.equals("")) {
            javax.swing.JOptionPane.showMessageDialog(this, "A XML Notification needs to be created first!");
        }
        
        if (xmlInterface == null) {
            javax.swing.JOptionPane.showMessageDialog(this,"You must first configure the Siena server!");
            return;
        }
        
        notificationView.append("Trying to send: \n"+xmlNotification+"\n");
        
        try {
            xmlInterface.publish(xmlNotification);
        } catch (siena.SienaException exception) {
            notificationView.append("Error when trying to publish the notification.\n");
            notificationView.append("Error is: "+exception.getMessage());            
        }
    }//GEN-LAST:event_sendAction

    private void clearRulesButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearRulesButtonActionPerformed
        if (xmlInterface == null) {
            javax.swing.JOptionPane.showMessageDialog(this,"You must first configure the Siena server!");
            return;
        }
        
        xmlInterface.clearUserRules();
    }//GEN-LAST:event_clearRulesButtonActionPerformed

    private void setRulesButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setRulesButtonActionPerformed
        String filename = null;
        javax.swing.JFileChooser fileChooser = new javax.swing.JFileChooser();

        if (xmlInterface == null) {
            javax.swing.JOptionPane.showMessageDialog(this,"You must first configure the Siena server!");
            return;
        }
        
        if (lastDir != null) {
            fileChooser.setCurrentDirectory(lastDir);
        }

        int returnValue = fileChooser.showOpenDialog(this);
        if (returnValue == javax.swing.JFileChooser.APPROVE_OPTION) {
            lastDir = fileChooser.getSelectedFile();
            filename = lastDir.getAbsolutePath();
        } else {
            return;
        }
        
        try {
            xmlInterface.setUserRules(filename);
        } catch (siena.SienaException exception) {
            notificationView.append("Error while trying to add rules: "+exception.getMessage()+"\n");
            notificationView.append("No rules added.\n");
            return;
        }
    }//GEN-LAST:event_setRulesButtonActionPerformed

    private void notificationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_notificationButtonActionPerformed
        if (notificationDialog == null) {
            notificationDialog = new NotificationBuilderDialog(this,true);
        }        
        notificationDialog.setDirectory(lastDir);
        notificationDialog.setVisible(true);        
    }//GEN-LAST:event_notificationButtonActionPerformed

    private void xschemaButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_xschemaButtonActionPerformed
        String filename = null;
        javax.swing.JFileChooser fileChooser = new javax.swing.JFileChooser();

        if (xmlInterface == null) {
            javax.swing.JOptionPane.showMessageDialog(this,"You must first configure the Siena server!");
            return;
        }

        if (lastDir != null) {
            fileChooser.setCurrentDirectory(lastDir);
        }
        int returnValue = fileChooser.showOpenDialog(this);
        if (returnValue == javax.swing.JFileChooser.APPROVE_OPTION) {
            lastDir = fileChooser.getSelectedFile();
            filename = lastDir.getAbsolutePath();
        } else {
            return;
        }
        try {
            xmlInterface.setStyleSheet(filename);
        } catch (java.io.IOException exception) {
            notificationView.append("Error while dealing with the XSchema file: "+exception.getMessage()+"\n");
            notificationView.append("XSchema file not set.\n");
            return;
        }
    }//GEN-LAST:event_xschemaButtonActionPerformed

    private void serverButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_serverButtonActionPerformed
        SienaConfigurationDialog dialog = new SienaConfigurationDialog(this,true);
        dialog.show();
        this.serverName = dialog.getSienaServer();
        this.serverPort = dialog.getPort();
        
        if (serverName == null || serverPort == 0) {
            notificationView.append("Siena server configuration canceled\n");
            return;
        }
        try {
            notificationView.append("Trying to connect to Siena Server: "+serverName+" at "+serverPort+"\n");
            xmlInterface = new siena.xml.XMLClient("tcp:"+serverName+":"+serverPort);
        } catch (siena.comm.InvalidSenderException exception) {
            notificationView.append("Invalid siena server. "+exception.toString()+"\n");
            return;
        }
        
        notificationView.append("Siena server identified."); 
    }//GEN-LAST:event_serverButtonActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new ServerSideFrame().show();
    }

    private NotificationBuilderDialog notificationDialog;    

    public java.io.File lastDir;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JMenuItem sendMenuItem;
    private javax.swing.JMenuItem clearMenuItem;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea notificationView;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JButton serverButton;
    private javax.swing.JButton xschemaButton;
    private javax.swing.JButton notificationButton;
    private javax.swing.JButton setRulesButton;
    private javax.swing.JButton clearRulesButton;
    private javax.swing.JButton sendButton;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JButton exitButton;
    // End of variables declaration//GEN-END:variables

}
