//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: SienaConfigurationDialog.java,v 1.1.1.1 2002/06/10 20:53:31 jgiacomo Exp $
//
/*
 * SienaConfigurationDialog.java
 *
 * Created on November 26, 2001, 4:14 PM
 */

package siena.xml.demo;

import javax.swing.JOptionPane;

/**
 *
 * @author  CorliC
 */
public class SienaConfigurationDialog extends javax.swing.JDialog {

    /** Creates new form SienaConfigurationDialog */
    public SienaConfigurationDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        serverLabel = new javax.swing.JLabel();
        portLabel = new javax.swing.JLabel();
        serverTextField = new javax.swing.JTextField();
        portTextField = new javax.swing.JTextField();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        setTitle("Siena Configuration");
        setName("sienaConfigDialog");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        serverLabel.setText("Siena Server");
        serverLabel.setToolTipText("The name of the siena server to connect to");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(20, 10, 0, 0);
        getContentPane().add(serverLabel, gridBagConstraints1);
        
        portLabel.setText("Port");
        portLabel.setToolTipText("Port to use when connecting to the server");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(29, 10, 0, 0);
        getContentPane().add(portLabel, gridBagConstraints1);
        
        serverTextField.setToolTipText("Enter the name of the server");
        serverTextField.setColumns(12);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.gridheight = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(20, 9, 0, 0);
        getContentPane().add(serverTextField, gridBagConstraints1);
        
        portTextField.setToolTipText("Enter a number only");
        portTextField.setColumns(5);
        portTextField.setText("10910");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridheight = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(29, 9, 0, 0);
        getContentPane().add(portTextField, gridBagConstraints1);
        
        okButton.setText("OK");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(29, 16, 0, 0);
        getContentPane().add(okButton, gridBagConstraints1);
        
        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(29, 29, 0, 0);
        getContentPane().add(cancelButton, gridBagConstraints1);
        
        pack();
    }//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // Add your handling code here:
        sienaServer = serverTextField.getText().trim();
        if (sienaServer.equals("")) {
            serverTextField.setText("ENTER NAME HERE");
            javax.swing.JOptionPane.showMessageDialog(this, "Siena Server not specified.");
            return;
        };
        try {
            port = Integer.parseInt(portTextField.getText());
        } catch (Exception e) {
            javax.swing.JOptionPane.showMessageDialog(this, "Invalid Port Number.", "Error", JOptionPane.ERROR_MESSAGE);
            return;
        }
        this.closeDialog(null);
    }//GEN-LAST:event_okButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    public String getSienaServer() {
        return sienaServer;
    }    

    public int getPort() {
        return port;
    }    

    private String sienaServer = null;
    
    private int port = 0;
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel serverLabel;
    private javax.swing.JLabel portLabel;
    private javax.swing.JTextField serverTextField;
    private javax.swing.JTextField portTextField;
    private javax.swing.JButton okButton;
    private javax.swing.JButton cancelButton;
    // End of variables declaration//GEN-END:variables

}
