//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: InequalityConditionTest.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//

/*
 * InequalityConditionTest.java
 * JUnit based test
 *
 * Created on December 2, 2001, 9:29 PM
 */                

package siena.xml.tests;

import siena.xml.rules.InequalityCondition;
import junit.framework.*;

/**
 *
 * @author unknown
 */                                
public class InequalityConditionTest extends TestCase {
    
    public InequalityConditionTest(java.lang.String testName) {
        super(testName);
    }        
    
    public static void main(java.lang.String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    public static Test suite() {
        TestSuite suite = new TestSuite(InequalityConditionTest.class);
        
        return suite;
    }
    
    /** Test of meetCondition method, of class siena.xml.rules.InequalityCondition. */
    public void testMeetCondition() {
        InequalityCondition condition = null;
        
        System.out.println(" - Test: InequalityCondition - meetCondition method");
        
        condition = new InequalityCondition(0, true);
        assertTrue("Test failed for the less than operation given a value of -1 when condition is 0", condition.meetCondition("-1"));
        assertTrue("Test failed for the less than operation given a value of 1 when condition is 0", !condition.meetCondition("1"));

        condition = new InequalityCondition(0.0, true);
        assertTrue("Test failed for the less than operation given a value of -0.1 when condition is 0.0", condition.meetCondition("-0.1"));
        assertTrue("Test failed for the less than operation given a value of 0.1 when condition is 0.0", !condition.meetCondition("0.1"));

        condition = new InequalityCondition(0, false);
        assertTrue("Test failed for the greater than operation given a value of 1 when condition is 0", condition.meetCondition("1"));
        assertTrue("Test failed for the greater than operation given a value of -1 when condition is 0", !condition.meetCondition("-1"));

        condition = new InequalityCondition(0.0, false);
        assertTrue("Test failed for the greater than operation given a value of 0.1 when condition is 0.0", condition.meetCondition("0.1"));
        assertTrue("Test failed for the greater than operation given a value of -0.1 when condition is 0.0", !condition.meetCondition("-0.1"));        
    }
}
